'--------------------------------------------------------------------------
'  DeMo-SWECHECK.vbs Script
'
' This script is intended to grab releases from the SWECHEK website.
' It's code is based in my NFORce script.
'
'
' This is version 1.1
' Contact me @ http://www.samurize.com/modules/ipboard/index.php?showuser=230
'
'--------------------------------------------------------------------------


'----------------- CONFIGURATION -----------------
Const SWECHECK_ADDR = "http://www.swecheck.net/"'SWECHECK's website address
Const NO_FILTERED = "No releases..."		'Message to show when no releases passed filter settings

'This version lets you customize the output through "smart tags"
'All you have to do is provide a string along with the following tags:
'<title> Is replaced by the release name (ie: SomeGame (C) 2003 - SomeCompany)
'<group> Is replaced by the group who released (ie: Fairlight)
'<date> Is replaced with the release date (ie: 2004-07-06)
'<size> Is replaced with the release size (ie: 90x15 MB)
'<type> Only showed if you use the GetMixedList function, replaced by the release type (ie: SVCD)

'Now lets go for a quick example.
'If you set the RELEASE_FORMAT Const below to: "In <date>, <group> released: <title>"
'The result would be: "In 2003-11-04, DeMo release: SWECHECK Script v1.0"

'Another example: "<title> by <group>"
'The result is: "SWECHECK Script v1.0 by DeMo"

'You can use any characters you want as long as you keep the tags enclosed by the < >
'One more example: "<title> by -==[<group>]==-"
'Result: "SWECHECK Script v1.0 by -==[DeMo]==-"

'I think you got it..
'Now set the RELEASE_FORMAT to wathever you like!

Const RELEASE_FORMAT = "<date> | <title> | <size> | <group>"
'----------------- CONFIGURATION -----------------



'----------------- DO NOT CHANGE ANYTHING BELOW THIS LINE!!! -----------------

Function GetMixedList(NUMBER_OF_RELEASES, Filter)
    GetMixedList = getISOReleases("l", NUMBER_OF_RELEASES, Filter)
End Function

Function GetDivX(NUMBER_OF_RELEASES, Filter)
    GetDivX = getISOReleases("divx", NUMBER_OF_RELEASES, Filter)
End Function

Function GetSVCD(NUMBER_OF_RELEASES, Filter)
    GetSVCD = getISOReleases("svcd", NUMBER_OF_RELEASES, Filter)
End Function

Function GetVCD(NUMBER_OF_RELEASES, Filter)
    GetVCD = getISOReleases("vcd", NUMBER_OF_RELEASES, Filter)
End Function

Function GetMVIDS(NUMBER_OF_RELEASES, Filter)
    GetMVIDS = getISOReleases("mvids", NUMBER_OF_RELEASES, Filter)
End Function

Function GetMP3(NUMBER_OF_RELEASES, Filter)
    GetMP3 = getISOReleases("mp3", NUMBER_OF_RELEASES, Filter)
End Function

Function GetApps(NUMBER_OF_RELEASES, Filter)
    GetApps = getISOReleases("apps", NUMBER_OF_RELEASES, Filter)
End Function

Function GetGames(NUMBER_OF_RELEASES, Filter)
    GetGames = getISOReleases("games", NUMBER_OF_RELEASES, Filter)
End Function

Function GetTV(NUMBER_OF_RELEASES, Filter)
    GetTV = getISOReleases("tv", NUMBER_OF_RELEASES, Filter)
End Function

Function GetDVDR(NUMBER_OF_RELEASES, Filter)
    GetDVDR = getISOReleases("dvd-r", NUMBER_OF_RELEASES, Filter)
End Function

Function GetXXX(NUMBER_OF_RELEASES, Filter)
    GetXXX = getISOReleases("xxx", NUMBER_OF_RELEASES, Filter)
End Function


Function getISOReleases(Section, TOTALRLS, Filter)


    Dim htmlResult
    ReDim strTitle(TOTALRLS), strGrp(TOTALRLS), strSize(TOTALRLS), strType(TOTALRLS), strDate(TOTALRLS), strRelease(TOTALRLS)

    If Section = "l" Then
        htmlResult = ReturnHTML(SWECHECK_ADDR & "default.asp")
    Else
        htmlResult = ReturnHTML(SWECHECK_ADDR & "default.asp?s=" & Section)
    End If


    WorkingResult = htmlResult

    
    Set RE = New RegExp
    RE.Global = True

    'Remove links to links & images & samples
    RE.Pattern = "<a onclick.*?></a>"
    WorkingResult = RE.Replace(WorkingResult, "")
    RE.Pattern = "<a href=""default.asp[?]s=.*?"">"
    WorkingResult = RE.Replace(WorkingResult, "")
    RE.Pattern = "<img.*?>"
    WorkingResult = RE.Replace(WorkingResult, "")
    RE.Pattern = "<a href=""javascript.*?</a>"
    WorkingResult = RE.Replace(WorkingResult, "")

    If Section = "l" Then

        'Get type
        RE.Pattern = "42px;"">(.*?)</a>"
        
    
    Set typetemp = RE.Execute(WorkingResult)
    For i = 0 To TOTALRLS - 1
      Set oMatch = typetemp(i)
      strType(i) = oMatch.SubMatches(0)
    Next
        
    End If

    'Get Date
    RE.Pattern = "[0-9]{4}[-][0-9]{2}[-][0-9]{2}"

    Set datetemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS -1
	strDate(i) = datetemp(i)
    Next


    'Get Name
     RE.Pattern = "title="".*?"">(.*?)</a>"

    Set titletemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS - 1
      Set oMatch = titletemp(i)
      strTitle(i) = oMatch.SubMatches(0)
    Next
    
    'Get Size
    RE.Pattern = "70px;"">(.*?)</td>"

    Set sizetemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS - 1
      Set oMatch = sizetemp(i)
      strSize(i) = oMatch.SubMatches(0)
    Next

    'Get Group
    RE.Pattern = "grupp=(.*?)"">"

    Set grptemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS - 1
      Set oMatch = grptemp(i)
      strGrp(i) = oMatch.SubMatches(0)
    Next

    
    For b = 0 To TOTALRLS - 1
	'Generate full release string
	strRelease(b) = RELEASE_FORMAT
	strRelease(b) = Replace(strRelease(b), "<group>", strGrp(b), 1, -1, 1)
	strRelease(b) = Replace(strRelease(b), "<title>", strTitle(b), 1, -1, 1)
	strRelease(b) = Replace(strRelease(b), "<size>", strSize(b), 1, -1, 1)
	strRelease(b) = Replace(strRelease(b), "<date>", strDate(b), 1, -1, 1)
	If Section = "l" Then
	    strRelease(b) = Replace(strRelease(b), "<type>", strType(b), 1, -1, 1)
	End if
    Next

    'Create the filter array
    If Filter <> "" Then FilterArray = Split(Filter, "|")

    For b = 0 To TOTALRLS - 1
        If Filter <> "" Then
            For c = 0 To UBound(FilterArray)
                If InStr(1, LCase(strRelease(b)), LCase(FilterArray(c))) > 0 Then
                    getISOReleases = getISOReleases & strRelease(b) & vbCrLf
                End If
            Next
        Else
            getISOReleases = getISOReleases & strRelease(b) & vbCrLf
        End If
    Next

    'Check if any releases passed filter settings
    If getISOReleases = "" Then
        getISOReleases = NO_FILTERED
    End If

End Function


Function ReturnHTML(sURL)
    Randomize
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
    objXMLHTTP.Open "GET", sURL, False
    objXMLHTTP.Send
    HTML = objXMLHTTP.responseBody
    Set objRS = CreateObject("ADODB.Recordset")
    objRS.Fields.Append "txt", 200, 45000, &H80
    objRS.Open
    objRS.AddNew
    objRS.Fields("txt").AppendChunk HTML
    ReturnHTML = objRS("txt").Value
    objRS.Close
    Set objRS = Nothing
    Set objXMLHTTP = Nothing
End Function
